Index: cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas
===================================================================
--- cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1676)
+++ cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1693)
@@ -2094,53 +2105,53 @@
 begin
   if FParentCombo <> nil then with Message do
-  begin
-    FDontClose := FALSE;
-    ListRect := ClientRect;                                                      //+
-    if FLongList then ListRect.Right := ListRect.Left + ClientWidthOfList(Self); //+
+    begin
+      FDontClose := FALSE;
+      ListRect := ClientRect; //+
+      if FLongList then ListRect.Right := ListRect.Left + ClientWidthOfList(Self); //+
     // if the mouse was clicked in the client area set ItemIndex ourselves
-    if PtInRect(ListRect, Point(XPos, YPos)) then                                //~
-    begin
-      AnItem := GetIndexFromY(YPos);
-      if AnItem < Items.Count then ItemIndex := AnItem;
-      FParentCombo.FwdClick(FParentCombo);
-      FDontClose := TRUE;
-    end;
+      if PtInRect(ListRect, Point(XPos, YPos)) then //~
+      begin
+        AnItem := GetIndexFromY(YPos);
+        if AnItem < Items.Count then ItemIndex := AnItem;
+        FParentCombo.FwdClick(FParentCombo);
+        FDontClose := TRUE;
+      end;
     // if the mouse was clicked on the scrollbar, send a message to make the scrolling happen
     // this is done with WM_NCLBUTTONDOWN, which is ignored if mousecapture is on, so we have
     // to turn mousecapture off, then back on since it's needed to hide the listbox
-    with ListRect do ScrollRect := Rect(Right + 1, Top, Self.Width - 2, Bottom); //~
-    if {(Items.Count > (FLargeChange + 1)) and} PtInRect(ScrollRect, Point(XPos, YPos)) then //~
-    begin
-      if FLongList then                                                    // for long lists
+      with ListRect do ScrollRect := Rect(Right + 1, Top, Self.Width - 2, Bottom); //~
+      if {(Items.Count > (FLargeChange + 1)) and} PtInRect(ScrollRect, Point(XPos, YPos)) then //~
       begin
-        ScreenPoint := PointToSmallPoint(FScrollBar.ScreenToClient(
-                                         Self.ClientToScreen(Point(XPos, YPos))));
-        MouseCapture := False;
-        SendMessage(FScrollBar.Handle, WM_LBUTTONDOWN, Message.Keys,
-                    MakeLParam(ScreenPoint.X, ScreenPoint.Y));
-        MouseCapture := True;
-      end else                                                             // for normal lists
-      begin
-        ScreenPoint := PointToSmallPoint(Self.ClientToScreen(Point(XPos, YPos)));
-        MouseCapture := False;
-        SendMessage(Self.Handle, WM_NCLBUTTONDOWN, HTVSCROLL,
-                    MakeLParam(ScreenPoint.X, ScreenPoint.Y));
-        MouseCapture := True;
-      end;
-    end
-    else
-    if(FCheckBoxes) then
-    begin
-      TmpRect := ListRect;
-      TmpRect.Top := TmpRect.Bottom;
-      TmpRect.Right := TmpRect.Left + Width;
-      inc(TmpRect.Bottom, CheckComboBtnHeight);
-      if PtInRect(TmpRect, Point(XPos, YPos)) then
-      begin
-        inc(TmpRect.Left, (TmpRect.right - TmpRect.Left) div 2);
-        FParentCombo.DropPanelBtnPressed(XPos <= TmpRect.Left, FALSE);
-      end;
-    end;
-  end;
+        if FLongList then // for long lists
+        begin
+          ScreenPoint := PointToSmallPoint(FScrollBar.ScreenToClient(
+            Self.ClientToScreen(Point(XPos, YPos))));
+          MouseCapture := False;
+          SendMessage(FScrollBar.Handle, WM_LBUTTONDOWN, Message.Keys,
+            MakeLParam(ScreenPoint.X, ScreenPoint.Y));
+          MouseCapture := True;
+        end else // for normal lists
+        begin
+          ScreenPoint := PointToSmallPoint(Self.ClientToScreen(Point(XPos, YPos)));
+          MouseCapture := False;
+          SendMessage(Self.Handle, WM_NCLBUTTONDOWN, HTVSCROLL,
+            MakeLParam(ScreenPoint.X, ScreenPoint.Y));
+          MouseCapture := True;
+        end;
+      end
+      else
+        if (FCheckBoxes) then
+        begin
+          TmpRect := ListRect;
+          TmpRect.Top := TmpRect.Bottom;
+          TmpRect.Right := TmpRect.Left + Width;
+          inc(TmpRect.Bottom, CheckComboBtnHeight);
+          if PtInRect(TmpRect, Point(XPos, YPos)) then
+          begin
+            inc(TmpRect.Left, (TmpRect.right - TmpRect.Left) div 2);
+            FParentCombo.DropPanelBtnPressed(XPos <= TmpRect.Left, FALSE);
+          end;
+        end;
+    end;
   inherited;
 end;
@@ -2162,18 +2173,18 @@
 
 begin
-  if(FRightClickSelect and (FParentCombo = nil)) then with Message do // List Boxes only, not Combo Boxes
-  begin
-    ListRect := ClientRect;                                                      //+
-    if FLongList then ListRect.Right := ListRect.Left + ClientWidthOfList(Self); //+
+  if (FRightClickSelect and (FParentCombo = nil)) then with Message do // List Boxes only, not Combo Boxes
+    begin
+      ListRect := ClientRect; //+
+      if FLongList then ListRect.Right := ListRect.Left + ClientWidthOfList(Self); //+
     // if the mouse was clicked in the client area set ItemIndex ourselves
-    if PtInRect(ListRect, Point(XPos, YPos)) then                                //~
-    begin
-      AnItem := GetIndexFromY(YPos);
-      if AnItem >= Items.Count then AnItem := -1;
-    end
-    else
-      AnItem := -1;
-    ItemIndex := AnItem;
-  end;
+      if PtInRect(ListRect, Point(XPos, YPos)) then //~
+      begin
+        AnItem := GetIndexFromY(YPos);
+        if AnItem >= Items.Count then AnItem := -1;
+      end
+      else
+        AnItem := -1;
+      ItemIndex := AnItem;
+    end;
   inherited;
 end;
@@ -2186,30 +2197,30 @@
 begin
   if FParentCombo <> nil then with Message do
-  begin
-    if(FCheckBoxes) then FDontClose := TRUE;
+    begin
+      if (FCheckBoxes) then FDontClose := TRUE;
     // if the mouse was clicked on the scrollbar, send a message to make the scrolling happen
     // this is done with WM_NCLBUTTONDOWN, which is ignored if mousecapture is on, so we have
     // to turn mousecapture off, then back on since it's needed to hide the listbox
-    with ClientRect do ScrollRect := Rect(Right + 1, Top, Self.Width - 2, Bottom);
-    if (Items.Count > (FLargeChange + 1)) and PtInRect(ScrollRect, Point(XPos, YPos)) then
-    begin
-      if FLongList then                                                    // for long lists
+      with ClientRect do ScrollRect := Rect(Right + 1, Top, Self.Width - 2, Bottom);
+      if (Items.Count > (FLargeChange + 1)) and PtInRect(ScrollRect, Point(XPos, YPos)) then
       begin
-        ScreenPoint := PointToSmallPoint(FScrollBar.ScreenToClient(
-                                         Self.ClientToScreen(Point(XPos, YPos))));
-        MouseCapture := False;
-        SendMessage(FScrollBar.Handle, WM_LBUTTONDOWN, Message.Keys,
-                    MakeLParam(ScreenPoint.X, ScreenPoint.Y));
-        MouseCapture := True;
-      end else                                                             // for normal lists
-      begin
-        ScreenPoint := PointToSmallPoint(Self.ClientToScreen(Point(XPos, YPos)));
-        MouseCapture := False;
-        SendMessage(Self.Handle, WM_NCLBUTTONDOWN, HTVSCROLL,
-                    MakeLParam(ScreenPoint.X, ScreenPoint.Y));
-        MouseCapture := True;
-      end; {if FLongList}
-    end; {if (Items.Count)}
-  end; {if FParentCombo}
+        if FLongList then // for long lists
+        begin
+          ScreenPoint := PointToSmallPoint(FScrollBar.ScreenToClient(
+            Self.ClientToScreen(Point(XPos, YPos))));
+          MouseCapture := False;
+          SendMessage(FScrollBar.Handle, WM_LBUTTONDOWN, Message.Keys,
+            MakeLParam(ScreenPoint.X, ScreenPoint.Y));
+          MouseCapture := True;
+        end else // for normal lists
+        begin
+          ScreenPoint := PointToSmallPoint(Self.ClientToScreen(Point(XPos, YPos)));
+          MouseCapture := False;
+          SendMessage(Self.Handle, WM_NCLBUTTONDOWN, HTVSCROLL,
+            MakeLParam(ScreenPoint.X, ScreenPoint.Y));
+          MouseCapture := True;
+        end; {if FLongList}
+      end; {if (Items.Count)}
+    end; {if FParentCombo}
   inherited;
 end;
@@ -2258,5 +2269,5 @@
   GetCursorPos(APoint);
   APoint := ScreenToClient(APoint);
-  MouseMove([], APoint.X, APoint.Y);                // assume nothing in ShiftState for now
+  MouseMove([], APoint.X, APoint.Y); // assume nothing in ShiftState for now
 end;
 
@@ -2311,9 +2322,9 @@
 procedure TORListBox.DestroyItems;
 var
-  ItemCount,i: Integer;
+  ItemCount, i: Integer;
   ItemRec: PItemRec;
 
 begin
-  if(not FItemsDestroyed) then
+  if (not FItemsDestroyed) then
   begin
     ItemCount := Perform(LB_GETCOUNT, 0, 0);
@@ -2321,5 +2332,5 @@
     begin
       FFromSelf := True;
-      ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, i, 0));
+      ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, i, 0));
       FFromSelf := False;
       if Assigned(ItemRec) then
@@ -2338,22 +2349,22 @@
 
 begin
-  if(not FCheckBoxes) or (idx < 0) or (idx >= Items.Count) then exit;
+  if (not FCheckBoxes) or (idx < 0) or (idx >= Items.Count) then exit;
   OldFromSelf := FFromSelf;
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, idx, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, idx, 0));
   FFromSelf := OldFromSelf;
-  if(assigned(ItemRec)) then
-  begin
-    if(FAllowGrayed) then
+  if (assigned(ItemRec)) then
+  begin
+    if (FAllowGrayed) then
     begin
       case ItemRec^.CheckedState of
         cbUnchecked: ItemRec^.CheckedState := cbGrayed;
-        cbGrayed:    ItemRec^.CheckedState := cbChecked;
-        cbChecked:   ItemRec^.CheckedState := cbUnchecked;
+        cbGrayed: ItemRec^.CheckedState := cbChecked;
+        cbChecked: ItemRec^.CheckedState := cbUnchecked;
       end;
     end
     else
     begin
-      if(ItemRec^.CheckedState = cbUnchecked) then
+      if (ItemRec^.CheckedState = cbUnchecked) then
         ItemRec^.CheckedState := cbChecked
       else
@@ -2363,7 +2374,7 @@
   Rect := ItemRect(Idx);
   InvalidateRect(Handle, @Rect, FALSE);
-  if(assigned(FOnClickCheck)) then
+  if (assigned(FOnClickCheck)) then
     FOnClickCheck(Self, idx);
-  if(assigned(FParentCombo)) then
+  if (assigned(FParentCombo)) then
     FParentCombo.UpdateCheckEditBoxText;
 end;
@@ -2389,14 +2400,68 @@
   uItemTip.Hide;
   inherited MouseDown(Button, Shift, X, Y);
-  if(FCheckBoxes) and (X >= 0) and (X <= Width) and (Y >= 0) and (Y <= Height) then
+  if (FCheckBoxes) and (X >= 0) and (X <= Width) and (Y >= 0) and (Y <= Height) then
   begin
     idx := GetIndexFromY(Y);
-    if(idx >= 0) then
-    begin
-      if(FCheckEntireLine) then
+    if (idx >= 0) then
+    begin
+      if (FCheckEntireLine) then
         ToggleCheckBox(idx)
       else
-        if(X < CheckWidth) then ToggleCheckBox(idx);
-    end;
+        if (X < CheckWidth) then ToggleCheckBox(idx);
+    end;
+  end;
+end;
+
+procedure TORListBox.SetHintProperties(Restore: Boolean; MainForm: TComponent);
+var
+  i, x: integer;
+  Component: TComponent;
+begin
+   //Clear the array if we are not restoring it
+  if not restore then SetLength(HintArray, 0);
+
+  //Loop through all the components on the form
+  for i := 0 to TForm(MainForm).ComponentCount - 1 do begin
+    Component := TForm(MainForm).Components[i];
+    if (Component is TControl) then begin
+      if not restore then begin
+        //Increase our array and set our record
+        SetLength(HintArray, Length(HintArray) + 1);
+        HintArray[high(HintArray)].ObjectName := Component.Name;
+        HintArray[high(HintArray)].ObjectHint := GetStrProp(Component, 'Hint');
+        //Now clear out the component's hint
+        SetStrProp(Component, 'Hint', '');
+      end else begin
+        //Loop through the array and find this component's hint
+        for x := Low(HintArray) to High(HintArray) do begin
+          if Component.Name = HintArray[x].ObjectName then begin
+            //Once found reset the hint and break out of the loop
+            SetStrProp(Component, 'Hint', HintArray[x].ObjectHint);
+            break;
+          end;
+        end;
+      end;
+    end;
+  end;
+
+  //Now deal with the form itself
+  if not restore then begin
+    //Increase our array and set our record
+    SetLength(HintArray, Length(HintArray) + 1);
+    HintArray[high(HintArray)].ObjectName := TForm(MainForm).Name;
+    HintArray[high(HintArray)].ObjectHint := TForm(MainForm).Hint;
+    //Now clear out the Forms's hint
+    TForm(MainForm).Hint := '';
+  end else begin
+      //Loop through the array and find this Forms's hint
+    for x := Low(HintArray) to High(HintArray) do begin
+      if TForm(MainForm).Name = HintArray[x].ObjectName then begin
+        //Once found reset the hint and break out of the loop
+        TForm(MainForm).Hint := HintArray[x].ObjectHint;
+        break;
+      end;
+    end;
+    //Now clear the arrau since we are done using it
+    SetLength(HintArray, 0);
   end;
 end;
@@ -2408,8 +2473,19 @@
 var
   AnItem: Integer;
-  TrueOffset :integer;
+  TrueOffset: integer;
   TipPos: TPoint;
 begin
   inherited MouseMove(Shift, X, Y);
+
+  //If the drop down is visible and the hint hasn't been changed then clear the hint and save    the original hint
+  if assigned(FParentCombo) then begin
+    //agp change
+    //if (FParentCombo.FDropPanel.Visible) and (TForm(self.Owner.Owner).Hint <> '') then begin
+    if (FParentCombo.FDropPanel.Visible) and ((GetParentForm(self) <> nil) and (Length(HintArray) = 0)) then begin
+      SetHintProperties(False, GetParentForm(Self));
+    end;
+  end;
+
+
   if (not FItemTipEnable) or (not Application.Active) then Exit;
   { Make sure mouse really moved before continuing.  For some reason, MouseMove gets called
@@ -2422,4 +2498,5 @@
   if not PtInRect(ClientRect, Point(X, Y)) then
   begin
+    If FParentCombo = nil then MouseCapture := False;
     uItemTip.Hide;
     FItemTipActive := False;
@@ -2449,14 +2526,14 @@
 procedure TORListBox.MeasureItem(Index: Integer; var Height: Integer);
 var
-  Txt:string;
-
-begin
-  if(FHideSynonyms) and (fSynonymChars <> '') then
-  begin
-    if(FCreatingItem) then
+  Txt: string;
+
+begin
+  if (FHideSynonyms) and (fSynonymChars <> '') then
+  begin
+    if (FCreatingItem) then
       Txt := FCreatingText
     else
-      Txt :=  Items[Index];
-    if(IsSynonym(Txt)) then Height := 0;
+      Txt := Items[Index];
+    if (IsSynonym(Txt)) then Height := 0;
   end;
   inherited MeasureItem(Index, Height);
@@ -2465,5 +2542,5 @@
 procedure TORListBox.WMDestroy(var Message: TWMDestroy);
 begin
-  if(assigned(Owner)) and (csDestroying in Owner.ComponentState) then
+  if (assigned(Owner)) and (csDestroying in Owner.ComponentState) then
     DestroyItems;
   inherited;
@@ -2472,5 +2549,5 @@
 procedure TORListBox.CNDrawItem(var Message: TWMDrawItem);
 begin
-  if(FCheckBoxes) then
+  if (FCheckBoxes) then
     with Message.DrawItemStruct^ do
       inc(rcItem.Left, CheckWidth);
@@ -2482,5 +2559,5 @@
   Flags: Longint;
   ItemRec: PItemRec;
-  OldFromSelf :boolean;
+  OldFromSelf: boolean;
   BMap: TBitMap;
   i, DY: integer;
@@ -2489,5 +2566,5 @@
   ShowText: string;
 begin
-  if(assigned(FOnBeforeDraw)) then
+  if (assigned(FOnBeforeDraw)) then
     FOnBeforeDraw(Self, Index, Rect, State);
   if Assigned(OnDrawItem) then OnDrawItem(Self, Index, Rect, State)
@@ -2504,15 +2581,15 @@
       OldFromSelf := FFromSelf;
       FFromSelf := True;
-      ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));  // WParam: list index
+      ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0)); // WParam: list index
       FFromSelf := OldFromSelf;
 
-      if(FCheckBoxes) then
+      if (FCheckBoxes) then
       begin
-        if(assigned(ItemRec)) then
+        if (assigned(ItemRec)) then
         begin
           case ItemRec^.CheckedState of
             cbUnchecked:
               begin
-                if(FFlatCheckBoxes) then
+                if (FFlatCheckBoxes) then
                   BMap := GetORCBBitmap(iiFlatUnChecked, FBlackColorMode)
                 else
@@ -2521,21 +2598,21 @@
             cbChecked:
               begin
-                if(FFlatCheckBoxes) then
+                if (FFlatCheckBoxes) then
                   BMap := GetORCBBitmap(iiFlatChecked, FBlackColorMode)
                 else
                   BMap := GetORCBBitmap(iiChecked, FBlackColorMode);
               end;
-            else // cbGrayed:
-              begin
-                if(FFlatCheckBoxes) then
-                  BMap := GetORCBBitmap(iiFlatGrayed, FBlackColorMode)
-                else
-                  BMap := GetORCBBitmap(iiGrayed, FBlackColorMode);
-              end;
+          else // cbGrayed:
+            begin
+              if (FFlatCheckBoxes) then
+                BMap := GetORCBBitmap(iiFlatGrayed, FBlackColorMode)
+              else
+                BMap := GetORCBBitmap(iiGrayed, FBlackColorMode);
+            end;
           end;
         end
         else
         begin
-          if(FFlatCheckBoxes) then
+          if (FFlatCheckBoxes) then
             BMap := GetORCBBitmap(iiFlatGrayed, FBlackColorMode)
           else
@@ -2544,14 +2621,14 @@
         TmpR := Rect;
         TmpR.Right := TmpR.Left;
-        dec(TmpR.Left, CheckWidth+1);
+        dec(TmpR.Left, CheckWidth + 1);
         DY := ((TmpR.Bottom - TmpR.Top) - BMap.Height) div 2;
         Canvas.Draw(TmpR.Left, TmpR.Top + DY, BMap);
       end;
 
-      if(FTabPos[0] > 0) then
+      if (FTabPos[0] > 0) then
         Flags := (FTabPos[1] * 256) or Flags or DT_TABSTOP or DT_EXPANDTABS;
 
       ShowText := GetDisplayText(Index);
-      if(Style <> lbStandard) and (FTabPos[0] > 0) then
+      if (Style <> lbStandard) and (FTabPos[0] > 0) then
       begin
         for i := 1 to FTabPix[0] do
@@ -2559,8 +2636,8 @@
           Neg := (FTabPix[i] < 0);
           if Neg then FTabPix[i] := -FTabPix[i];
-          inc(FTabPix[i],Rect.Left-1);
+          inc(FTabPix[i], Rect.Left - 1);
           if Neg then FTabPix[i] := -FTabPix[i];
         end;
-        TabbedTextOut(Canvas.Handle, Rect.Left, Rect.Top+1, PChar(ShowText), Length(ShowText),
+        TabbedTextOut(Canvas.Handle, Rect.Left, Rect.Top + 1, PChar(ShowText), Length(ShowText),
           FTabPix[0], FTabPix[1], -1);
         for i := 1 to FTabPix[0] do
@@ -2568,5 +2645,5 @@
           Neg := (FTabPix[i] < 0);
           if Neg then FTabPix[i] := -FTabPix[i];
-          dec(FTabPix[i],Rect.Left-1);
+          dec(FTabPix[i], Rect.Left - 1);
           if Neg then FTabPix[i] := -FTabPix[i];
         end;
@@ -2578,14 +2655,14 @@
 end;
 
-function TORListBox.GetIndexFromY(YPos :integer) :integer;
-begin
-  if(FHideSynonyms) then
-  begin
-    Result := TopIndex-1;
+function TORListBox.GetIndexFromY(YPos: integer): integer;
+begin
+  if (FHideSynonyms) then
+  begin
+    Result := TopIndex - 1;
     repeat
       inc(Result);
-      if(Perform(LB_GETITEMHEIGHT, Result, 0) > 0) then
-        dec(YPos,ItemHeight);
-    until((YPos < 0) or (Result >= Items.Count));
+      if (Perform(LB_GETITEMHEIGHT, Result, 0) > 0) then
+        dec(YPos, ItemHeight);
+    until ((YPos < 0) or (Result >= Items.Count));
   end
   else
@@ -2602,10 +2679,10 @@
   ScrollCount, ScrollPos, InitialTop, i: Integer;
 begin
-  if FLongList then                                 // -- special long list processing - begin
-  begin
-    if (Value = SFI_TOP) or (Value = SFI_END) then  // scroll to top or bottom
+  if FLongList then // -- special long list processing - begin
+  begin
+    if (Value = SFI_TOP) or (Value = SFI_END) then // scroll to top or bottom
     begin
       if Value = SFI_TOP then ScrollPos := 0 else ScrollPos := 100;
-      ScrollTo(Self, scPosition, ScrollPos);        // ScrollTo is scrollbar event
+      ScrollTo(Self, scPosition, ScrollPos); // ScrollTo is scrollbar event
       FScrollBar.Position := ScrollPos;
       if ScrollPos = 0 then Value := FFocusIndex else Value := FFocusIndex + FLargeChange;
@@ -2614,6 +2691,6 @@
       InitialTop := TopIndex;
       ScrollCount := Value - InitialTop;
-      ScrollPos := 50;                              // arbitrary, can be anything from 1-99
-      if ScrollCount < 0 then                       // scroll backwards
+      ScrollPos := 50; // arbitrary, can be anything from 1-99
+      if ScrollCount < 0 then // scroll backwards
       begin
         if ScrollCount = -FLargeChange then ScrollTo(Self, scPageUp, ScrollPos) else
@@ -2622,5 +2699,5 @@
         Value := Value + (FCurrentTop - InitialTop);
       end;
-      if ScrollCount > FLargeChange then            // scroll forwards
+      if ScrollCount > FLargeChange then // scroll forwards
       begin
         if ScrollCount = (FLargeChange * 2) then ScrollTo(Self, scPageDown, ScrollPos) else
@@ -2628,9 +2705,9 @@
         FScrollBar.Position := ScrollPos;
       end;
-      if(FHideSynonyms) then
+      if (FHideSynonyms) then
       begin
-        while((Perform(LB_GETITEMHEIGHT, Value, 0) = 0) and (Value >= 0) and (value < Items.Count)) do
+        while ((Perform(LB_GETITEMHEIGHT, Value, 0) = 0) and (Value >= 0) and (value < Items.Count)) do
         begin
-          if(Value < FFocusIndex) then
+          if (Value < FFocusIndex) then
             dec(Value)
           else
@@ -2639,5 +2716,5 @@
       end;
     end;
-  end;                                              // -- special long list processing - end
+  end; // -- special long list processing - end
   if (Value = SFI_END) or (not (Value < Items.Count)) then Value := Items.Count - 1;
   if (Value = SFI_TOP) or (Value < 0) then Value := 0;
@@ -2670,6 +2747,6 @@
 var
   TipPos: TPoint;
-  TrueOffset :integer;
-  TmpIdx :integer;
+  TrueOffset: integer;
+  TmpIdx: integer;
 begin
   // if listbox is dropdown combo but control is not focused -
@@ -2680,11 +2757,11 @@
   // if control is not focused -
   if (Screen.ActiveControl <> Self) and (Screen.ActiveControl <> Parent) then Exit;
-  if(FHideSynonyms) then
+  if (FHideSynonyms) then
   begin
     TrueOffset := TopIndex;
     TmpIdx := TopIndex;
-    while((TmpIdx < Message.wParam) and (TmpIdx < Items.Count)) do
-    begin
-      if(Perform(LB_GETITEMHEIGHT, TmpIdx, 0) > 0) then
+    while ((TmpIdx < Message.wParam) and (TmpIdx < Items.Count)) do
+    begin
+      if (Perform(LB_GETITEMHEIGHT, TmpIdx, 0) > 0) then
         inc(TrueOffset);
       inc(TmpIdx);
@@ -2695,5 +2772,5 @@
   TipPos := ClientToScreen(Point(0, (TrueOffset - TopIndex) * ItemHeight));
   //uItemTip.Show(Self, FFocusIndex, TipPos, NO_CATCH_MOUSE);
-  uItemTip.Show(Self, FFocusIndex, TipPos, FParentCombo = nil);  // if DropDown, no mousecapture
+  uItemTip.Show(Self, FFocusIndex, TipPos, FParentCombo = nil); // if DropDown, no mousecapture
 end;
 
@@ -2703,5 +2780,5 @@
   if (AnIndex < Items.Count) and (AnIndex > -1)
     then Result := StrToInt64Def(Piece(Items[AnIndex], FDelimiter, 1), 0)
-    else Result := 0;
+  else Result := 0;
 end;
 
@@ -2711,5 +2788,5 @@
   if ItemIndex > -1
     then Result := StrToInt64Def(Piece(Items[ItemIndex], FDelimiter, 1), 0)
-    else Result := 0;
+  else Result := 0;
 end;
 
@@ -2739,10 +2816,10 @@
   if FLongList then ListEnd := FWaterMark - 1 else ListEnd := Items.Count - 1;
   for i := 0 to ListEnd do if (GetIEN(i) = AnIEN) and (GetDisplayText(i) = AnItem) then
-  begin
-    ItemIndex := i;
-    Result := i;
-    ItemFound := True;
-    break;
-  end;
+    begin
+      ItemIndex := i;
+      Result := i;
+      ItemFound := True;
+      break;
+    end;
   if FLongList and not ItemFound then
   begin
@@ -2781,7 +2858,7 @@
     raise Exception.Create('List Index Out of Bounds');
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0));
   FFromSelf := False;
-  if(assigned(ItemRec)) then
+  if (assigned(ItemRec)) then
     Result := ItemRec^.Reference
   else
@@ -2797,7 +2874,7 @@
     raise Exception.Create('List Index Out of Bounds');
   FFromSelf := True;
-  ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Index, 0));
+  ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Index, 0));
   FFromSelf := False;
-  if(assigned(ItemRec)) then
+  if (assigned(ItemRec)) then
     ItemRec^.Reference := AReference;
 end;
@@ -2834,5 +2911,5 @@
 { returns the character based tab stops that are currently set, if any }
 begin
-  if(FTabPosInPixels) then
+  if (FTabPosInPixels) then
     Result := IntArrayToString(FTabPix)
   else
@@ -2849,7 +2926,7 @@
   for i := 2 to TabTmp[0] do
     if (abs(TabTmp[i]) < abs(TabTmp[i - 1])) or
-       (TabTmp[i] = TabTmp[i - 1]) then
+      (TabTmp[i] = TabTmp[i - 1]) then
       raise Exception.Create('Tab positions must be in ascending order');
-  if(FTabPosInPixels) then
+  if (FTabPosInPixels) then
   begin
     for i := 0 to TabTmp[0] do FTabPix[i] := TabTmp[i];
@@ -2866,5 +2943,5 @@
 procedure TORListBox.SetTabPosInPixels(const Value: boolean);
 begin
-  if(FTabPosInPixels <> Value) then
+  if (FTabPosInPixels <> Value) then
   begin
     FTabPosInPixels := Value;
@@ -2879,7 +2956,7 @@
   i, AveWidth: Integer;
 begin
-  FillChar(TabDlg,  SizeOf(TabDlg),  0);
+  FillChar(TabDlg, SizeOf(TabDlg), 0);
   AveWidth := FontWidthPixel(Self.Font.Handle);
-  if(FTabPosInPixels) then
+  if (FTabPosInPixels) then
   begin
     FillChar(FTabPos, SizeOf(FTabPos), 0);
@@ -2888,5 +2965,5 @@
     begin
       FTabPos[i] := FTabPix[i] div AveWidth;
-      TabDlg[i]  := (FTabPix[i] * 4) div AveWidth;
+      TabDlg[i] := (FTabPix[i] * 4) div AveWidth;
     end;
   end
@@ -2898,9 +2975,9 @@
     begin
       // do dialog units first so that pixels gets the same rounding error
-      TabDlg[i]  := FTabPos[i] * 4;        // 4 dialog units per character
+      TabDlg[i] := FTabPos[i] * 4; // 4 dialog units per character
       FTabPix[i] := (TabDlg[i] * AveWidth) div 4;
     end;
   end;
-  TabDlg[0]  := FTabPos[0];
+  TabDlg[0] := FTabPos[0];
   Perform(LB_SETTABSTOPS, TabDlg[0], Integer(@TabDlg[1]));
   Refresh;
@@ -2912,15 +2989,15 @@
 end;
 
-procedure TORListBox.SetHideSynonyms(Value :boolean);
-var
-  TmpIH :integer;
-
-begin
-  if(FHideSynonyms <> Value) then
-  begin
-    if((Value) and (not FLongList)) then
+procedure TORListBox.SetHideSynonyms(Value: boolean);
+var
+  TmpIH: integer;
+
+begin
+  if (FHideSynonyms <> Value) then
+  begin
+    if ((Value) and (not FLongList)) then
       raise Exception.Create('Hide Synonyms only allowed on Long Lists');
     FHideSynonyms := Value;
-    if(not FHideSynonyms) then
+    if (not FHideSynonyms) then
     begin
       Style := lbStandard;
@@ -2928,5 +3005,5 @@
     else
     begin
-      if(FSynonymChars = '') then
+      if (FSynonymChars = '') then
         FSynonymChars := '<>';
       TmpIH := ItemHeight;
@@ -2937,12 +3014,12 @@
 end;
 
-procedure TORListBox.SetSynonymChars(Value :string);
-begin
-  if(FSynonymChars <> Value) then
+procedure TORListBox.SetSynonymChars(Value: string);
+begin
+  if (FSynonymChars <> Value) then
   begin
     FSynonymChars := Value;
-    if((Value = '') and (FHideSynonyms)) then
+    if ((Value = '') and (FHideSynonyms)) then
       SetHideSynonyms(FALSE);
-    if(FHideSynonyms) then
+    if (FHideSynonyms) then
     begin
       SetHideSynonyms(FALSE);
@@ -2959,7 +3036,7 @@
 procedure TORListBox.SetStyle(Value: TListBoxStyle);
 begin
-  if(Value <> lbOwnerDrawVariable) and (FHideSynonyms) then
+  if (Value <> lbOwnerDrawVariable) and (FHideSynonyms) then
     FHideSynonyms := FALSE;
-  if(FCheckBoxes) and (Value = lbStandard) then
+  if (FCheckBoxes) and (Value = lbStandard) then
     FCheckBoxes := FALSE;
   inherited Style := Value;
@@ -3002,11 +3079,11 @@
   try
     TORStrings(Items).Verification := False;
-    HandleNeeded;                 // ensures that Items is valid if in the middle of RecreateWnd
+    HandleNeeded; // ensures that Items is valid if in the middle of RecreateWnd
     SaveListMode := FLongList;
     Strings := TStringList.Create;
     SaveItems := TList.Create;
-    FLongList := False;                               // so don't have to track WaterMark
+    FLongList := False; // so don't have to track WaterMark
     FFromSelf := True;
-    for i := 0 to Items.Count - 1 do                  // put pointers to TItemRec in SaveItems
+    for i := 0 to Items.Count - 1 do // put pointers to TItemRec in SaveItems
     begin
       ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, i, 0));
@@ -3014,17 +3091,17 @@
     end;
     Strings.Assign(Items);
-    Items.Clear;                                      // still FromSelf so don't dispose recs
+    Items.Clear; // still FromSelf so don't dispose recs
     FFromSelf := False;
-    for i := 0 to SaveItems.Count - 1 do              // use saved ItemRecs to rebuild listbox
+    for i := 0 to SaveItems.Count - 1 do // use saved ItemRecs to rebuild listbox
     begin
       ItemRec := SaveItems[i];
-      if(assigned(ItemRec)) then
+      if (assigned(ItemRec)) then
       begin
         Pos := Items.AddObject(Strings[i], ItemRec^.UserObject);
         // CQ 11491 - Changing TabPositions, etc. was wiping out check box status.
         FFromSelf := True;
-        ItemRec2 := PItemRec(SendMessage(Handle,LB_GETITEMDATA, Pos, 0));
+        ItemRec2 := PItemRec(SendMessage(Handle, LB_GETITEMDATA, Pos, 0));
         FFromSelf := False;
-        if(assigned(ItemRec2)) then
+        if (assigned(ItemRec2)) then
         begin
           ItemRec2^.Reference := ItemRec^.Reference;
@@ -3051,5 +3128,5 @@
     begin
       FreeScrollBar;
-      if(FHideSynonyms) then
+      if (FHideSynonyms) then
         SetHideSynonyms(FALSE);
     end;
@@ -3062,6 +3139,6 @@
   L, T, W, H, OffsetLT, OffsetWH: Integer;
 begin
-  if uNewStyle then begin OffsetLT := 2; OffsetWH := 4; end   // Win95
-               else begin OffsetLT := 0; OffsetWH := 0; end;  // Win3.1
+  if uNewStyle then begin OffsetLT := 2; OffsetWH := 4; end // Win95
+  else begin OffsetLT := 0; OffsetWH := 0; end; // Win3.1
   W := GetSystemMetrics(SM_CXVSCROLL);
   L := Left + Width - W - OffsetLT;
@@ -3076,5 +3153,5 @@
 begin
   FLongList := True;
-  if MultiSelect then MultiSelect := False;    // LongLists do not support multiple selections
+  if MultiSelect then MultiSelect := False; // LongLists do not support multiple selections
   FScrollBar := TScrollBar.Create(Self);
   FScrollBar.Kind := sbVertical;
@@ -3085,5 +3162,5 @@
   if FParentCombo = nil
     then FScrollBar.Parent := Parent
-    else FScrollBar.Parent := FParentCombo.FDropPanel;
+  else FScrollBar.Parent := FParentCombo.FDropPanel;
 end;
 
@@ -3092,5 +3169,5 @@
 begin
   FLongList := False;
-  FScrollBar.Free;  // don't call from destroy because scrollbar may already be free
+  FScrollBar.Free; // don't call from destroy because scrollbar may already be free
   FScrollBar := nil;
 end;
